{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}
{
  This file contains the definition of the TjmGridDataLink class.

  This class is derived from the VCL TDataLink class and serves as the link
  between the control and the database.
}
  TjmGridDataLink = class (TDataLink)
    Private
      FGrid : TColossalGrid ;
      FScrollOffset : LongInt ;
      FVisibleRecords : Integer ;
      FTrace : Boolean ;
      
    Protected
      procedure ActiveChanged ; Override ;
      procedure CheckBrowseMode ; Override ;
      procedure DataSetChanged ; Override ;
      procedure DataSetScrolled(Distance: Integer) ; Override ;
      procedure FocusControl(Field: TFieldRef) ; Override ;
      procedure EditingChanged ; Override ;
      procedure LayoutChanged ; Override ;
      procedure RecordChanged(Field : TField) ; Override ;
      procedure UpdateData ; Override ;

      Function GetRecordSetCount : LongInt ;

      Function GetCurrentRecordNumber : LongInt ;

    Public
      Constructor Create (AGrid : TColossalGrid) ;

      Property RecordSetCount : LongInt
               Read GetRecordSetCount ;
      Property VisibleRecords : Integer
               Read FVisibleRecords
               Write FVisibleRecords ;
    End ;
