{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}

{
  This file contains TColossalGrid methods that support bound operation.
}

Procedure TColossalGrid.DataLinkInactive ;
  Begin
  ChangeRecordCount (0) ;
  FindFields ;
  End ;

Procedure TColossalGrid.UpdateDataRecordCount ;
  Begin
  If (Mode = gmdatabase) Then
    Begin
    If FDataLink.Active Then
      Begin
      ChangeRecordCount (FDataLink.RecordCount) ;
      { Do this buffer updating the buffer count. }
      FDataLink.VisibleRecords := MaxVisibleRecords ;
      FDataLink.BufferCount := MaxVisibleRecords
      End
    Else
      Begin
      ChangeRecordCount (0) ;
      End ;
    End ;
  End ;

Procedure TColossalGrid.DataLayoutChanged ;
  Var
    OldActive : Boolean ;
  Procedure AutoLayoutChanged ;
    Var
      ICOL : Integer ;
    Begin
    If (FDataZone = 0) Or (FDataZone > ZoneCount) Then
      Exit ;

    Zones [FDataZone].ColumnCount := 0 ;
    Zones [FDataZone].ColumnCount := FDataLink.DataSet.FieldCount ;
    For ICol := 1 To Zones [FDataZone].ColumnCount Do
      Begin
      Zones [FDataZone].Columns [ICol].FFieldName := FDataLink.DataSet.Fields [ICol - 1].FieldName ;
      Zones [FDataZone].Columns [ICol].FColumnType := gctBound ;

      Canvas.Font := Columns [ICol].EffectiveHeaderFont ;

      If Length (Zones [FDataZone].Columns [ICol].FFieldName) > FDataLink.DataSet.Fields [Icol - 1].DataSize Then
        Begin
        Zones [FDataZone].Columns [ICol].Width := Canvas.TextWidth (Columns [ICol].FFieldName) + 4 ;
        End
      Else
        Begin
        Zones [FDataZone].Columns [ICol].Width := Canvas.TextWidth ('X') * FDataLink.DataSet.Fields [Icol - 1].DataSize + 4 ;
        End ;
      End ;
    LayoutChanged ;
    End ;
  Begin
  OldActive := Active ;
  Active := False ;

  If (FLayoutMode = lmAuto) And UsingDatabase Then
    AutoLayoutChanged ;

  FindFields ;
  Active := OldActive ;
  { Notify the user that the layout changed. }
  If Assigned (OnLayoutChanged) Then
    OnLayoutChanged (Self) ;


  End ;

{
  This procedure is called when there is a position change in the grid.

  Parameters:
    ARecord : The New Current Record
    ATop :    The Record to be displayed at the top of the grid.
}
Procedure TColossalGrid.DataChangeRecord (ARecord : LongInt) ;
  Var
    NewCell : TjmGridCell ;
  Begin
  If Usingdatabase Then
    Begin
    NewCell := CurrentCell ;
    NewCell.RecordNumber := ARecord ;
    ChangeCurrentCell (NewCell) ;
    End ;
  End ;

Function TColossalGrid.GetUsingDatabase : Boolean ;
  Begin
  Result := (FMode = gmDatabase) And FDataLink.Active And Not (csReading In ComponentState) ;
  End ;

Procedure TColossalGrid.DataLinkActive ;
  Begin
  If (Mode = gmdatabase) And Not (csReading In ComponentState) Then
    Begin
    UpdateDataRecordCount ;
    DataLayoutChanged ;
    End ;
  End ;

Procedure TColossalGrid.UpdateData ;
  Begin
  If EditorVisible Then
    Begin
    If Not (FActiveEditor Is TCustomEdit) Or (FActiveEditor As TCustomEdit).Modified Then
      Begin
      If Zones [FCurrentCell.Zone].Columns [FCurrentCell.Column].SaveToDatabase (GetEditorText (FActiveEditor)) Then
        Raise EAbort.Create ('Update Aborted') ; { Silent Exception }
      End ;
    HideEditor (True) ; { True => Set focus back to grid. }
    End
  Else
    Begin
    LayoutChanged ;
    End ;
  End ;

