{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}

{
  This file contains the implementation of TjmGridEdit class and the editor
  classes supported by the grid.
}

Constructor TjmGridEdit.Create (AOwner : TComponent) ;
  Begin
  Inherited Create (AOwner) ;
  BorderStyle := bsNone ;
  Visible := False ;
  Color := clWhite ;
  End ;


Procedure TjmGridEdit.KeyPress (var Key : Char) ;
  Begin
  (Parent As TjmGridZone).ParentGrid.EditorKeyPress (Self, Key) ;
  End ;

Procedure TjmGridEdit.KeyDown (Var Key : Word ; Shift : TShiftState) ;
  Var
    NewShift : TShiftState ;
  Begin
  Case Key Of
    VK_UP, VK_DOWN:
      (Parent As TjmGridZone).ParentGrid.EditorKeyDown (Self, Key, Shift) ;
    VK_LEFT, VK_RIGHT:
      If ssCtrl In Shift Then
        Begin
        NewShift := Shift - [ssCtrl] ;
        (Parent As TjmGridZone).ParentGrid.EditorKeyDown (Self, Key, NewShift) ;
        Key := 0 ;
        End ;
    End ;
  End ;

Procedure TjmGridEdit.WMGetDlgCode (var Message : TwmGetDlgCode) ;
  Begin
  Inherited ;
  Message.Result := Message.Result OR DLGC_WANTTAB ;
  End ;

Procedure TjmGridEdit.WMKillFocus (var Message : TWMKillFocus) ;
  Begin
  Inherited ;
  (Parent As TjmGridZone).ParentGrid.EditorKillFocus (Message) ;
  End ;


Constructor TjmGridMemo.Create (AOwner : TComponent) ;
  Begin
  Inherited Create (AOwner) ;
  BorderStyle := bsNone ;
  Visible := False ;
  End ;


Procedure TjmGridMemo.KeyPress (var Key : Char) ;
  Begin
  (Parent As TjmGridZone).ParentGrid.EditorKeyPress (Self, Key) ;
  End ;

Procedure TjmGridMemo.KeyDown (Var Key : Word ; Shift : TShiftState) ;
  Var
    NewShift : TShiftState ;
  Begin
  Case Key Of
    { If the user does a <CTRL/Arrow> combination then we pass that on to the
      grid without the CTRL.  The memo control needs arrow so we need to give
      the user a method to move out of the control. }
    VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT:
      If ssCtrl In Shift Then
        Begin
        NewShift := Shift - [ssCtrl] ;
        (Parent As TjmGridZone).ParentGrid.EditorKeyDown (Self, Key, NewShift) ;
        Key := 0 ;
        End ;
    End ;
  End ;

Procedure TjmGridMemo.WMGetDlgCode (var Message : TwmGetDlgCode) ;
  Begin
  Inherited ;
  If Not WantTabs Then
    Message.Result := Message.Result OR DLGC_WANTTAB ;
  End ;

Procedure TjmGridMemo.WMKillFocus (var Message : TWMKillFocus) ;
  Begin
  Inherited ;
  (Parent As TjmGridZone).ParentGrid.EditorKillFocus (Message) ;
  End ;



Constructor TjmGridMaskEdit.Create (AOwner : TComponent) ;
  Begin
  Inherited Create (AOwner) ;
  BorderStyle := bsNone ;
  Visible := False ;
  End ;


Procedure TjmGridMaskEdit.KeyPress (var Key : Char) ;
  Begin
  (Parent As TjmGridZone).ParentGrid.EditorKeyPress (Self, Key) ;
  End ;

Procedure TjmGridMaskEdit.KeyDown (Var Key : Word ; Shift : TShiftState) ;
  Var
    NewShift : TShiftState ;
  Begin
  Case Key Of
    { If the user does a <CTRL/Arrow> combination then we pass that on to the
      grid without the CTRL.  The memo control needs arrow so we need to give
      the user a method to move out of the control. }
    VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT:
      If ssCtrl In Shift Then
        Begin
        NewShift := Shift - [ssCtrl] ;
        (Parent As TjmGridZone).ParentGrid.EditorKeyDown (Self, Key, NewShift) ;
        End ;
    End ;
  End ;

Procedure TjmGridMaskEdit.WMGetDlgCode (var Message : TwmGetDlgCode) ;
  Begin
  Inherited ;
  Message.Result := Message.Result ;
  End ;

Procedure TjmGridMaskEdit.WMKillFocus (var Message : TWMKillFocus) ;
  Begin
  Inherited ;
  (Parent As TjmGridZone).ParentGrid.EditorKillFocus (Message) ;
  End ;



{ Grid Combo Box }

Constructor TjmGridComboBox.Create (AOwner : TComponent) ;
  Begin
  Inherited Create (AOwner) ;
  Visible := False ;
//  BorderStyle := bsNone ;
  ControlStyle := ControlStyle - [csFramed] ;
  Ctl3D := False ;
  End ;


Procedure TjmGridComboBox.KeyPress (var Key : Char) ;
  Begin
  (Parent As TjmGridZone).ParentGrid.EditorKeyPress (Self, Key) ;
  End ;

Procedure TjmGridComboBox.KeyDown (Var Key : Word ; Shift : TShiftState) ;
  Var
    NewShift : TShiftState ;
  Begin
  Case Key Of
    { If the user does a <CTRL/Arrow> combination then we pass that on to the
      grid without the CTRL.  The memo control needs arrow so we need to give
      the user a method to move out of the control. }
    VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT:
      If ssCtrl In Shift Then
        Begin
        NewShift := Shift - [ssCtrl] ;
        (Parent As TjmGridZone).ParentGrid.EditorKeyDown (Self, Key, NewShift) ;
        End ;
    End ;
  End ;

Procedure TjmGridComboBox.WMGetDlgCode (var Message : TwmGetDlgCode) ;
  Begin
  Inherited ;
  Message.Result := Message.Result OR DLGC_WANTTAB ;
  End ;

Procedure TjmGridComboBox.WMKillFocus (var Message : TWMKillFocus) ;
  Begin
  Inherited ;
  If (Message.FocusedWnd <> EditHandle)
     And (Message.FocusedWnd <> ListHandle) Then
    Begin
    (Parent As TjmGridZone).ParentGrid.EditorKillFocus (Message) ;
    End ;
  End ;

Procedure TjmGridComboBox.CreateParams (var Params : TCreateParams) ;
  Begin
  Inherited CreateParams (Params) ;
  End ;


