{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}
{
  This file contains TColossalGrid methods that are Windows message handlers.
}

Procedure TColossalGrid.WMGetDlgCode (var Message : TwmGetDlgCode) ;
  Begin
  Inherited ;
  If UseArrows Then
    Message.Result := Message.Result Or DLGC_WANTARROWS ;
  If UseTabs Then
    Message.Result := Message.Result Or DLGC_WANTTAB ;
  End ;

Procedure TColossalGrid.WMSize (var Message : TWmSize) ;
  Begin
  Inherited ;
  ResizeGrid ;
  End ;

{
  In the set focus event we want to make the header active.
}
Procedure TColossalGrid.WMSetFocus (var Message : TWMSetFocus) ;
  Begin
  Inherited ;
  { If focus is going from the editor to the grid then we do not need to repaint. }
  If (FActiveEditor = Nil) Or (Message.FocusedWnd <> FActiveEditor.Handle) Then
    RedrawHeader ;

  If EditorVisible Then
    ActiveEditor.SetFocus ;
  End ;

{
  In the kill focus event we want to make the header inactive and get rid of
  of the editor.
}
Procedure TColossalGrid.WMKillFocus (var Message : TWMKillFocus) ;
  Begin
  Inherited ;
  { Do not make any changes if it is the editor that is receiving focus. }
  If Not GridControlsWindow (Message.FocusedWnd) Then
    Begin
    { If We are editing then make sure the user is not entering garbage. }
    If EditorVisible And Columns [FCurrentCell.Column].UpdateValue (GetEditorText (FActiveEditor)) Then
      Begin
      FActiveEditor.SetFocus ;
      Exit ;
      End ;
    RedrawHeader ;
    HideEditor (False) ; { False => Do not set focus back to the grid. }
    End
  Else If EditorVisible Then
    Begin
    ActiveEditor.SetFocus ;
    End ;
  End ;


Procedure TColossalGrid.CNExit (var Message : TCMExit) ;
  Begin
  If EditorVisible Then
    HideEditor (False) ;
  Inherited ;
  End ;

