{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}

{
  This file contains information methods for the TColossalGrid class.
}

Function TColossalGrid.AnyZonesHaveScrollBars : Boolean ;
  Var
    IZone : Integer ;
  Begin
  For IZone := 1 To ZoneCount Do
    Begin
    If Zones [IZone].HasHorizontalScrollBar Then
      Begin
      Result := True ;
      Exit ;
      End ;
    End ;
  Result := False ;
  End ;

Function TColossalGrid.IsCurrentCell (AZone : Cardinal ;
                                      ACol : Cardinal ;
                                      ARecord : LongInt) : Boolean ;
  Begin
  If (FCurrentCell.Zone = AZone)
     And (FCurrentCell.Column = ACol)
     And (FCurrentCell.RecordNumber = ARecord) Then
    Begin
    Result := True
    End
  Else
    Begin
    Result := False
    End ;
  End ;


Function TColossalGrid.IsCellBoxed (AZone : Cardinal ;
                                    ACol : Cardinal ;
                                    ARecord : LongInt) : Boolean ;
  Begin
  Case FSelectMode Of
    smRecord:
      Result := False ;
    smCell, smCellAndRecord:
      Result := IsCurrentCell (AZone, ACol, ARecord) ;
    smNone:
      Result := False ;
    else
      Raise Exception.Create ('Internal Error - Invalid Select Mode') ;
    End ;
  End ;


Function TColossalGrid.IsCellSelected (AZone : Cardinal ;
                                       ACol : Cardinal ;
                                       ARecord : LongInt) : Boolean ;
  Begin
  Case FSelectMode Of
    smRecord, smCellAndRecord:
      Begin
      If ARecord = RecordIndex Then
        Result := True
      Else
        Result := False ;
      End ;
    smCell:
      Begin
      If (AZone = ZoneIndex) And (ARecord = RecordIndex) And (ACol = ColumnIndex) Then
        Result := True
      Else
        Result := False ;
      End ;
    smNone:
      Result := False ;
    else
      Raise Exception.Create ('Internal Error - Invalid Select Mode') ;
    End ;
  End ;

{
  This function determines if any grid component has input focus.
}
Function TColossalGrid.HasControl : Boolean ;
  Var
    IZone : Integer ;
  Begin
  Result := True ;
  If Focused Then
    Exit ;

  If (FActiveEditor <> Nil) And FActiveEditor.Focused THen
    Exit ;

  For IZone := 1 To ZoneCount Do
    Begin
    If Zones [IZone].Focused Then
      Exit ;
    End ;
  Result := False ;
  End ;

Function TColossalGrid.WindowValid : Boolean ;
  Begin
  Result := Visible And (Parent <> Nil)
  End ;

{
  This function determines if a specified Window is owned by the grid.
}
Function TColossalGrid.GridControlsWindow (Window : HWND) : Boolean ;
  Var
    IZone : Integer ;
  Begin
  Result := True ;
  If Window = Handle THen
    Exit ;

  If EditorVisible And (Window = FActiveEditor.Handle) Then
    Exit ;

  If VisibleScrollBar (FVScrollBar) And (FVScrollBar.Handle = Window) THen
    Exit ;

  If VisibleScrollBar (FHScrollBar) And (FHScrollBar.Handle = Window) THen
    Exit ;

  For IZone := 1 To ZoneCount Do
    Begin
    If Zones [IZone].Handle = Window Then
      Exit ;
    End ;

  Result := False ;
  End ;

{
  This function returns the form the control is on.
}
Function TColossalGrid.GetOwnerForm : TForm ;
  Var
    Control : TComponent ;
  Begin
  Control := Owner ;
  While Control <> Nil Do
    Begin
    If (Control Is TForm) Then
      Begin
      Result := TForm (Control) ;
      Exit ;
      End ;
    Control := Control.Owner ;
    End ;
  Result := Nil ;
  End ;

