{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}

{
  This file contains the implementation for List classes used by the
  TColossalGrid control.
}

Function TjmGridZoneList.GetItems (Index : Cardinal) : TjmGridZone ;
  Begin
  If (Index < 1) Or (Index > Count) Then
    Raise Exception.CreateFmt ('Zone index (%d) for get is outsize of range 1..%d', [Index, Count]) ;
  Result := Inherited Items [Index - 1] ;
  End ;

Procedure TjmGridZoneList.Delete (Index : Cardinal) ;
  Var
    Zone : TjmGridZone ;
  Begin
  If (Index < 1) Or (Index > Count) Then
    Raise Exception.CreateFmt ('Zone index (%d) for delete is outsize of range 1..%d', [Index, Count]) ;
  Zone := Items [Index] ;
  Inherited Delete (Index - 1) ;
  Zone.Free ;
  End ;

Function TjmGridZoneList.IndexOf (AItem : TjmGridZone) : Cardinal ;
  Begin
  Result := Inherited IndexOf (AItem) + 1 ;
  End ;

Procedure TjmGridZoneList.Insert (Index : Cardinal ; AItem : TjmGridZone) ;
  Begin
  Inherited Insert (Index - 1, AItem) ;
  End ;

Procedure TjmGridZoneList.Move (OldPosition : Cardinal ; NewPosition : Cardinal) ;
  var
    Zone : TjmGridZone ;
  Begin
  Zone := Items [OldPosition] ;
  { We use the inherited version since we do not want to delete the object. }
  inherited Delete (OldPosition - 1) ;
  If NewPosition > Count Then
    Add (Zone)
  Else
    Insert (NewPosition, Zone) ;
  End ;

Function TjmGridRowList.GetItems (Index : Cardinal) : TjmGridRow ;
  Begin
  If (Index < 1) Or (Index > Count) Then
    Raise Exception.CreateFmt ('Row index (%d) for get is outsize of range 1..%d', [Index, Count]) ;
  Result := Inherited Items [Index - 1] ;
  End ;

Procedure TjmGridRowList.Delete (Index : Cardinal) ;
  Var
    Row : TjmGridRow ;
  Begin
  If (Index < 1) Or (Index > Count) Then
    Raise Exception.CreateFmt ('Row index (%d) for delete is outsize of range 1..%d', [Index, Count]) ;
  Row := Items [Index] ;
  Inherited Delete (Index - 1) ;
  Row.Free ;
  End ;

Function TjmGridRowList.IndexOf (AItem : TjmGridRow) : Cardinal ;
  Begin
  Result := Inherited IndexOf (AItem) + 1 ;
  End ;

Procedure TjmGridRowList.Insert (Index : Cardinal ; AItem : TjmGridRow) ;
  Begin
  Inherited Insert (Index - 1, AItem) ;
  End ;

Procedure TjmGridRowList.Move (OldPosition : Cardinal ; NewPosition : Cardinal) ;
  var
    Row : TjmGridRow ;
  Begin
  Row := Items [OldPosition] ;
  { We use the inherited version since we do not want to delete the object. }
  inherited Delete (OldPosition - 1) ;
  If NewPosition > Count Then
    Add (Row)
  Else
    Insert (NewPosition, Row) ;
  End ;

Function TjmGridColumnList.GetItems (Index : Cardinal) : TjmGridColumn ;
  Begin
  If (Index < 1) Or (Index > Count) Then
    Raise Exception.CreateFmt ('Column index (%d) for get is outsize of range 1..%d', [Index, Count]) ;
  Result := Inherited Items [Index - 1] ;
  End ;

Procedure TjmGridColumnList.Delete (Index : Cardinal) ;
  Var
    Column : TjmGridColumn ;
  Begin
  If (Index < 1) Or (Index > Count) Then
    Raise Exception.CreateFmt ('Column index (%d) for delete is outsize of range 1..%d', [Index, Count]) ;
  Column := Items [Index] ;
  Inherited Delete (Index - 1) ;
  Column.Free ;
  End ;

Function TjmGridColumnList.IndexOf (AItem : TjmGridColumn) : Cardinal ;
  Begin
  Result := Inherited IndexOf (AItem) + 1 ;
  End ;

Procedure TjmGridColumnList.Insert (Index : Cardinal ; AItem : TjmGridColumn) ;
  Begin
  Inherited Insert (Index - 1, AItem) ;
  End ;

Procedure TjmGridColumnList.Move (OldPosition : Cardinal ; NewPosition : Cardinal) ;
  var
    Column : TjmGridColumn ;
  Begin
  Column := Items [OldPosition] ;
  { We use the inherited version since we do not want to delete the object. }
  inherited Delete (OldPosition - 1) ;
  If NewPosition > Count Then
    Add (Column)
  Else
    Insert (NewPosition, Column) ; { TList is Zero based. }
  End ;

