{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}
{
  This file contains the definition for the TjmGridRow class.

  This class represents a row within a zone.
}
  TjmGridRow = class (TComponent)
    Private
      FZone : TjmGridZone ;
      FOverride : TjmGridOverrideSettings ;

      FBackgroundColor : TColor ;
      FMaxColumns : Cardinal ;
      FFirstColumn : Cardinal ;
      FFont : TFont ;
      FRowHeight : Cardinal ;
      FRowLineStyle : TjmGridLineStyle ;
      FRowLineColor : TColor ;

      { Property Functions }
      Function GetBackgroundColor : TColor ;
      Procedure SetBackgroundColor (AColor : TColor) ;
      Function GetColumns (Index : Cardinal) : TjmGridColumn ;
      Function GetColumnCount : Cardinal ;
      Procedure SetFont (AFont : TFont) ;
      Function GetRowHeight : Cardinal ;
      Procedure SetRowHeight (AValue : Cardinal) ;
      Function GetRowLineStyle : TjmGridLineStyle ;
      Procedure SetRowLineStyle (AStyle : TjmGridLineStyle) ;
      Function GetRowLineColor : TColor ;
      Procedure SetRowLineColor (AColor : TColor) ;
      Procedure SetMaxColumns (AMax : Cardinal) ;
      Procedure SetOverride (AValue : TjmGridOverrideSettings) ;
      Function GetParentGrid : TColossalGrid ;

      { Info Functions }
      Function ColumnAtOffset (AOffset : Cardinal) : Cardinal ;
      Function LastNonHiddenColumn : Cardinal ;
      Function GetColumnOffset (ACol : Cardinal) : Cardinal ;
      Function RowWidth : Cardinal ;

      { Drawing Functions }
      Procedure DrawFooter (ACanvas : TCanvas ; ARect : TRect ; XOffset : Integer) ;
      Procedure DrawRecords (RecordNumber : LongInt ;
                             ACanvas : TCanvas ;
                             ARect : TRect ;
                             XOffset : Integer) ;
      Procedure DrawHeader (ACanvas : TCanvas ; ARect : TRect ; XOffset : Integer) ;
      Procedure DrawVerticalLines (ACanvas : TCanvas ; ARect : TRect ; XOffset : Integer) ;

      Function StoreAppearanceProperties : Boolean ;

      Procedure FontChanged (Sender : TObject) ;

    Protected
      Function EffectiveFont : TFont ;

    Public      {*** TjmGridRow ***}
      Constructor Create (AZone : TComponent) ; Override ;
      Destructor Destroy ; Override ;

      Property Columns [Index : Cardinal] : TjmGridColumn
               Read GetColumns ;
      Property ParentZone : TjmGridZone
               Read FZone ;
      Property ParentGrid : TColossalGrid
               Read GetParentGrid ;

    Published
      Property BackgroundColor : TColor
               Read GetBackgroundColor
               Write SetBackgroundColor
               Stored StoreAppearanceProperties ;
      Property ColumnCount : Cardinal
               Read GetColumnCount
               Stored False ;
      Property Font : TFont
               Read FFont
               Write SetFont
               Stored StoreAppearanceProperties ;
      Property RowHeight : Cardinal
               Read GetRowHeight
               Write SetRowHeight ;
      Property RowLineColor : TColor
               Read GetRowLineColor
               Write SetRowLineColor ;
      Property RowLineStyle : TjmGridLineStyle
               Read GetRowLineStyle
               Write SetRowLineStyle ;
      Property MaxColumns : Cardinal
               Read FMaxColumns
               Write SetMaxColumns
               Default 0 ;
      Property OverrideSettings : TjmGridOverrideSettings
               Read FOverride
               Write SetOverride
               Default [] ;
    End ;      {*** TjmGridRow ***}

