{
  Copyright 1997, Colosseum Builders, Inc.

  This software may be freely reistributed as long as this copyright notice
  is included and as long as modifications are documented at the top of the
  file.

  This software may be used under licence from Colosseum Builders, Inc. No
  transfer of ownership is made.

  This software may only be used on an "as-is" basis. There is no warranty of
  any kind.

  This software may only be included in other software if the author assumes
  all liability. Colosseum Builders, Inc. cannot ensure that its software will
  work correctly in any system.

  This software may be used without a fee in software that is distributed
  with complete source code to all users.

  If this software is incorporated in a system that is not distributed with
  complete source code then a licencing fee of $75 per developer workstation
  must be paid to Colosseum Builders, Inc. NJ customers must include sales
  tax (As of 1-Jan-1997 $4.50 for a total of $79.50). Checks should be made
  out to Colosseum Builders, Inc and mailed to

  Colosseum Builders, Inc
  E101 103 Park Ave
  Summit NJ 07901

}


{
  Event Handler: WM_SETCURSOR

  Description:

    We are only concerted tiwh Client-Area hit tests.

    This event is used to determine what mouse pointer should be displayed.  If
    we are over a resizing point then we need to display the appropriate resize
    cursor.

}

{
  This file contains methods that implement handlers for Windows messages.
}

Procedure TjmGridZone.WMSetCursor(var Msg : TWMSetCursor) ;
  Var
    Position : TjmGridPosition ;
  Begin
  If csReading in ComponentState Then
    Exit ;

  Cursor := ParentGrid.Cursor ;

  { We only deal with the client area. }
  If Msg.HitTest = HTCLIENT Then
    Begin
    Position := ZonePosition [FHitTestPoint.X, FHitTestPoint.Y] ;

    Case Position.GridLocation Of
      glRecordSeparator:
        Begin
        If Not ParentGrid.DisableRecordResize Then
          Begin
          SetCursor (Screen.Cursors [crVSplit]) ;
          Exit ;
          End ;
        End ;

      glCell, glHeader, glFooter:
        Begin
        If (Position.ColumnLocation = gclSeparator)
           And Not ParentGrid.DisableColumnResize And Not DisableColumnResize Then
          Begin
          SetCursor (Screen.Cursors [crHSplit]) ;
          Exit ;
          End ;
        End ;
      End ;
    End ;

  Inherited ;
  End ;

{
  Event Handler: WM_NCHITTEST

  Description:

    The sole purpose of intercepting this message is to save the last location
    of the mouse pointer so that we can use it when we process the WM_SETCURSOR
    message that will soon follow.
}
procedure TjmGridZone.WMNCHitTest(var Msg : TWMNCHitTest) ;
  Begin
  Inherited ;
  { We save this value here to be used in the WMSetCursor event
    which does not give use the position.
  }
  FHitTestPoint := ScreenToClient (SmallPointToPoint (Msg.Pos)) ;
  End ;

{
  Event Handler: WM_SETFOCUS

  Description:

    The grid zone should never recieve input focus.  If we do then we need
    to transfer focus to the grid.
}
Procedure TjmGridZone.WMSetFocus (var msg : TWMSetFocus) ;
  Begin
  ParentGrid.SetFocus ;
  End ;

Procedure TjmGridZone.WMHScroll (Var Message : TWMHScroll) ;
  Var
    NewOffset : LongInt ;
  Begin
  NewOffset := FLeftOffset ;
  Case Message.ScrollCode Of
    SB_BOTTOM:
      NewOffset := Width - RowWidth ;

    SB_ENDSCROLL:
      ;

    SB_LINEDOWN:
               { The Delta (5) has to be a small value that is larger than
                 the widest line width. }
      NewOffset :=  NextRightScrollPosition (FLeftOffset + 5) ;

    SB_LINEUP:
      NewOffset :=  NextLeftScrollPosition (FLeftOffset - 1) ;

    SB_PAGEDOWN:
      NewOffset :=  NextRightScrollPosition (FLeftOffset + Width Div 2) ;

    SB_PAGEUP:
      NewOffset :=  NextLeftScrollPosition (FLeftOffset - Width Div 2) ;

    SB_THUMBPOSITION:
      NewOffset := Message.Pos ;

    SB_THUMBTRACK:
      NewOffset := Message.Pos ;

    SB_TOP:
      NewOffset := 0 ;

    End ;

  If NewOffset < 0 Then
    NewOffset := 0 ;

  If Width > RowWidth Then
    NewOffset := 0
  Else If NewOffset > (RowWidth - Width) Then
    NewOffset := RowWidth - Width ;

  MakeLeftOffset (NewOffset) ;
  SetScrollPosition ;

  End ; { TjmGridZone.HorizontalScrollHandler }

Procedure TjmGridZone.WMEraseBkgnd (Var Message : TWMEraseBkgnd) ;
  Begin
  { We never erase the background. }
  End ;

